/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 *
 * This software is a multi-platform and portable application based on
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s
 * possible to calculate indicators «RhoMéO» to monitor quality,
 * fonctionalities and urban and agricultural pressures of wetlands.
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p07;

import fr.cenra.rhomeo.api.data.Protocol;
import fr.cenra.rhomeo.api.process.Process;
import fr.cenra.rhomeo.api.process.ProcessContext;
import fr.cenra.rhomeo.core.list.HumidZoneType;
import fr.cenra.rhomeo.api.process.AbstractIndicator;
import fr.cenra.rhomeo.protocol.TaxonOperator;
import java.util.HashSet;
import java.util.Set;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

/**
 *
 * @author Samuel Andrés (Geomatys)
 */
@Component(I11.NAME)
public class I11 extends AbstractIndicator {

    public static final String NAME = "I11";
    public static final String REMARKS = "Intégrité du peuplement d’amphibiens";

    @Autowired
    @Qualifier(P07.NAME)
    private Protocol protocol;

    @Autowired
    SimpsonSpi simpsonSpi;

    @Autowired
    SBSpi sbSpi;

    @Autowired
    SRSpi srSpi;

    @Autowired
    I2PASpi i2paSpi;

    @Autowired
    ShfDescription shfDescription;

    @Autowired
    AmpByCountyDescription ampDescription;

    public I11() {
        super(NAME, REMARKS);
    }

    @Override
    public Protocol getProtocol() {
        return protocol;
    }

    @Override
    public Set<Process> createProcesses(ProcessContext ctx) {
        final TaxonOperator op = TaxonOperator.getOrCreate(ctx);
        final SimpsonProcess simpsonProcess = new SimpsonProcess(this, op);
        final StenoProcess steneoProcess = new StenoProcess(this, op);
        final I2paProcess i2paProcess = new  I2paProcess(this, op, steneoProcess, simpsonProcess);
        final Set<Process> processes = new HashSet<>(3);
        processes.add(simpsonProcess);
        processes.add(steneoProcess);
        processes.add(i2paProcess);

        return processes;
    }

    @Override
    public String getDefaultIndex() {
        return I11.NAME;
    }

    /**
     *
     * @return
     */
    @Override
    public Set<String> getZoneTypeCodes() {
        final Set<String> result = new HashSet<>();
        for(final HumidZoneType type : HumidZoneType.values()){
            if(!type.equals(HumidZoneType.GRANDS_ESTUAIRES)
                    && !type.equals(HumidZoneType.BAIES_ESTUAIRES))
            result.add(type.getCode());
        }
        return result;
    }
}
